| LUFA Library 140302 |

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Macros | Functions | Variables
USB Interface Management (EFM32GG)
USB Interface Management

USB Controller definitions for the EFM32 Giant Gecko microcontrollers. More...

## Macros
#define | USB_STREAM_TIMEOUT_MS 100

## Functions
static void | USB_Attach (void) ATTR_ALWAYS_INLINE
static void | USB_Detach (void) ATTR_ALWAYS_INLINE
void | USB_Disable (void)
void | USB_Init (uint8_t *endpoint_desc)
void | USB_ResetInterface (void)
static bool | USB_VBUS_GetStatus (void) ATTR_WARN_UNUSED_RESULT ATTR_ALWAYS_INLINE

## Variables
USBD_Device_TypeDef * | dev
volatile uint8_t | USB_CurrentMode
volatile uint8_t | USB_Options

## USB Controller Option Masks
#define | USB_OPT_GCLK_SRC_OSC (1 << 2)
#define | USB_OPT_GCLK_SRC_PLL (0 << 2)
#define | USB_OPT_GCLK_CHANNEL_0 (1 << 3)
#define | USB_OPT_GCLK_CHANNEL_1 (0 << 3)

## Detailed Description

Functions, macros, variables, enums and types related to the setup and management of the USB interface.

## Macro Definition Documentation

#define USB_OPT_GCLK_CHANNEL_0 (1 << 3)

Selects PLL or External Oscillator 0 as the USB Generic Clock source module input clock.

#define USB_OPT_GCLK_CHANNEL_1 (0 << 3)

Selects PLL or External Oscillator 1 as the USB Generic Clock source module input clock.

#define USB_OPT_GCLK_SRC_OSC (1 << 2)

Selects one of the system's main clock oscillators as the input clock to the USB Generic Clock source generation module. This indicates that an external oscillator should be used directly instead of an internal PLL clock source.

#define USB_OPT_GCLK_SRC_PLL (0 << 2)

Selects one of the system's PLL oscillators as the input clock to the USB Generic Clock source generation module. This indicates that one of the device's PLL outputs should be used instead of an external oscillator source.

#define USB_STREAM_TIMEOUT_MS 100

Constant for the maximum software timeout period of the USB data stream transfer functions (both control and standard) when in either device or host mode. If the next packet of a stream is not received or acknowledged within this time period, the stream function will fail.

This value may be overridden in the user project makefile as the value of the USB_STREAM_TIMEOUT_MS token, and passed to the compiler using the -D switch.

## Function Documentation

static void USB_Attach | ( | void |  | ) |
| inline static

Attaches the device to the USB bus. This announces the device's presence to any attached USB host, starting the enumeration process. If no host is present, attaching the device will allow for enumeration once a host is connected to the device.

This is inexplicably also required for proper operation while in host mode, to enable the attachment of a device to the host. This is despite the bit being located in the device-mode register and despite the datasheet making no mention of its requirement in host mode.

static void USB_Detach | ( | void |  | ) |
| inline static

Detaches the device from the USB bus. This has the effect of removing the device from any attached host, ceasing USB communications. If no host is present, this prevents any host from enumerating the device once attached until USB_Attach() is called.

void USB_Disable | ( | void |  | ) |

Shuts down the USB interface. This turns off the USB interface after deallocating all USB FIFO memory, endpoints and pipes. When turned off, no USB functionality can be used until the interface is restarted with the USB_Init() function.

void USB_Init | ( | uint8_t * | endpoint_desc | ) |

Main function to initialize and start the USB interface. Once active, the USB interface will allow for device connection to a host when in device mode, or for device enumeration while in host mode.

As the USB library relies on interrupts for the device and host mode enumeration processes, the user must enable global interrupts before or shortly after this function is called. In device mode, interrupts must be enabled within 500ms of this function being called to ensure that the host does not time out whilst enumerating the device. In host mode, interrupts may be enabled at the application's leisure however enumeration will not begin of an attached device until after this has occurred.

Calling this function when the USB interface is already initialized will cause a complete USB interface reset and re-enumeration.

Parameters

  [in] | endpoint_desc | endpoint descriptor

void USB_ResetInterface | ( | void |  | ) |

Resets the interface, when already initialized. This will re-enumerate the device if already connected to a host, or re-enumerate an already attached device when in host mode.

static bool USB_VBUS_GetStatus | ( | void |  | ) |
| inline static

Determines if the VBUS line is currently high (i.e. the USB host is supplying power).

Returns
  Boolean `true` if the VBUS line is currently detecting power from a host, `false` otherwise.

## Variable Documentation

USBD_Device_TypeDef* dev

volatile uint8_t USB_CurrentMode

Indicates the mode that the USB interface is currently initialized to, a value from the USB_Modes_t enum.

Attention
  This variable should be treated as read-only in the user application, and never manually changed in value.

Note
  When the controller is initialized into UID auto-detection mode, this variable will hold the currently selected USB mode (i.e. USB_MODE_Device or USB_MODE_Host). If the controller is fixed into a specific mode (either through the `USB_DEVICE_ONLY` or `USB_HOST_ONLY` compile time options, or a limitation of the USB controller in the chosen device model) this will evaluate to a constant of the appropriate value and will never evaluate to USB_MODE_None even when the USB interface is not initialized.

volatile uint8_t USB_Options

Indicates the current USB options that the USB interface was initialized with when USB_Init() was called. This value will be one of the `USB_MODE_*` masks defined elsewhere in this module.

Attention
  This variable should be treated as read-only in the user application, and never manually changed in value.